unit uEditarFichaBiomasaEmbalsable;

interface

uses
  {$IFDEF WINDOWS}
   Windows,
   {$ELSE}
   LCLType,
   {$ENDIF}
 Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uBaseEditoresFichas, StdCtrls, ExtCtrls, Grids, uFichasLPD, uCosaConNombre,
  usalasdejuego, uBaseEditoresFichasGeneradores,
  uSalasDeJuegoParaEditor, uBiomasaEmbalsable, uGeneradores,
  uEditarCentralesEncadenadas, utilidades,
  uconstantesSimSEE, uFechas, xMatDefs, uverdoc, uOpcionesSimSEEEdit;

type

  { TEditarFichaBiomasaEmbalsable }

  TEditarFichaBiomasaEmbalsable = class(TBaseEditoresFichasGeneradores)
    ecvea_impuesto: TEdit;
    ePMax: TEdit;
    ePEC: TEdit;
    ePEE: TEdit;
    efd: TEdit;
    eTMR: TEdit;
    lbl_cvea_impuesto: TLabel;
    lblPMax: TLabel;
    lblPEC: TLabel;
    lblPEE: TLabel;
    LblFD: TLabel;
    lblTMR: TLabel;
    LFIni: TLabel;
    BGuardar: TButton;
    BCancelar: TButton;
    EFIni: TEdit;
    CBPeriodicidad: TCheckBox;
    PPeriodicidad: TPanel;
    LFinPeriodo: TLabel;
    LIniPeriodo: TLabel;
    LLargoPeriodo: TLabel;
    EFFinPeriodo: TEdit;
    EFIniPeriodo: TEdit;
    sgPeriodicidad: TStringGrid;
    ELargoPeriodo: TEdit;
    CBLargoPeriodo: TComboBox;
    BAyuda: TButton;
    procedure EditEnter(Sender: TObject);
    procedure CBPeriodicidadClick(Sender: TObject);
    procedure CambiosForm(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure BGuardarClick(Sender: TObject); override;
    procedure BAyudaClick(Sender: TObject);
  protected
    function validarFormulario: boolean; override;
  private
    Generador: TBiomasaEmbalsable;
  public
    constructor Create(AOwner: TComponent; cosaConNombre: TCosaConNombre;
      ficha: TFichaLPD; sala: TSalaDeJuego); override;
  end;

var
  EditarFichaBiomasaEmbalsable: TEditarFichaBiomasaEmbalsable;

implementation

uses SimSEEEditMain, uBaseAltasEditores;

  {$R *.lfm}

constructor TEditarFichaBiomasaEmbalsable.Create(AOwner: TComponent;
  cosaConNombre: TCosaConNombre; ficha: TFichaLPD; sala: TSalaDeJuego);
var
  fichaAux: TFichaBiomasaEmbalsable;
  i: integer;
begin
  inherited Create(AOwner, cosaConNombre, ficha, sala);
  Generador := cosaConNombre as TBiomasaEmbalsable;
  inherited llenarCamposPeriodicidad(CBLargoPeriodo, ELargoPeriodo,
    EFIniPeriodo, EFFinPeriodo, sgPeriodicidad, CBPeriodicidad, ficha, PPeriodicidad);
  if (ficha <> nil) then
  begin
    fichaAux := ficha as TFichaBiomasaEmbalsable;
    self.EFIni.Text := FSimSEEEdit.fechaIniToString(fichaAux.fecha);
    self.ePMax.Text := FloatToStr(fichaAux.PMax);
    self.ePEC.Text := FloatToStr(fichaAux.PEC);
    self.ePEE.Text := FloatToStr(fichaAux.PEE);
    self.efd.Text := FloatToStr(fichaAux.fd);
    self.eTMR.Text := FloatToStr(fichaAux.TMR);
    self.ecvea_impuesto.Text:= FloatToStr( fichaAux.cvea_impuesto );
    guardado := True;
  end
  else
  begin
    self.EFIni.Text := '';
    self.ePMax.Text := '';
    self.ePEC.Text := '';
    self.ePEE.Text := '';
    self.efd.Text := '';
    self.eTMR.Text := '';
    self.ecvea_impuesto.Text := '';
    guardado := false;
  end;
end;

function TEditarFichaBiomasaEmbalsable.validarFormulario(): boolean;
begin
  inherited validarFormulario;
  Result := inherited validarEditFecha(EFIni) and
    inherited validarPeriodicidad(CBPeriodicidad, CBLargoPeriodo,
    ELargoPeriodo, EFIniPeriodo, EFFinPeriodo,
    sgPeriodicidad) and validarEditFloat(
    ePMax) and validarEditFloat(
    ePEC) and validarEditFloat(
    ePEE) and validarEditFloat(
    efd) and validarEditFloat(eTMR) and validarEditFloat(ecvea_impuesto);
end;

procedure TEditarFichaBiomasaEmbalsable.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarFichaBiomasaEmbalsable.CBPeriodicidadClick(Sender: TObject);
begin
  inherited switchPanelPeriodicidad(CBPeriodicidad, PPeriodicidad);
end;

procedure TEditarFichaBiomasaEmbalsable.CambiosForm(Sender: TObject);
begin
  guardado := False;
end;

procedure TEditarFichaBiomasaEmbalsable.EditExit(Sender: TObject);
begin

end;



procedure TEditarFichaBiomasaEmbalsable.BCancelarClick(Sender: TObject);
begin
  inherited BCancelarClick(Sender);
end;

procedure TEditarFichaBiomasaEmbalsable.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;

procedure TEditarFichaBiomasaEmbalsable.FormCreate(Sender: TObject);
begin
  utilidades.AgregarFormatoFecha(LFIni);
end;


procedure TEditarFichaBiomasaEmbalsable.BGuardarClick(Sender: TObject);
var
  periodo: TPeriodicidad;
begin
  if validarFormulario then
  begin
    if not CBPeriodicidad.Checked then
      periodo := nil
    else
      periodo := inherited darPeriodicidad(CBLargoPeriodo, ELargoPeriodo,
        EFIniPeriodo, EFFinPeriodo, sgPeriodicidad);


    ficha := TFichaBiomasaEmbalsable.Create(
      capa, FSimSEEEdit.StringToFecha(EFIni.Text), periodo,
      StrToFloat(efd.Text), StrToFloat(eTMR.Text), StrToFloat(
      ePMax.Text), StrToFloat(ePEC.Text), StrToFloat(ePEE.Text), StrToFloat( ecvea_impuesto.Text ));


    ModalResult := mrOk;
  end;
end;


procedure TEditarFichaBiomasaEmbalsable.BAyudaClick(Sender: TObject);
begin
  verdoc(self, TBiomasaEmbalsable);
end;

initialization
end.
