unit uEditarTBiomasaEmbalsable;

  {$MODE Delphi}

interface

uses
    {$IFDEF WINDOWS}
  Windows,
  {$ENDIF}
 Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids,
  uEditarActorConFichas,
  uFichasLPD,
  uBaseEditoresActores,
  uBaseEditoresCosasConNombre,
  uSalasDeJuego,
  uCosaConNombre,
  utilidades,
  uOpcionesSimSEEEdit,
  uverdoc,
  uConstantesSimSEE,
  xMatDefs,
  uBiomasaEmbalsable;

type

  { TEditarTBiomasaEmbalsable }

  TEditarTBiomasaEmbalsable = class(TEditarActorConFichas)
    btEditarForzamientos: TButton;
    cbCleanDevelopmentMechanism: TCheckBox;
    cbLowCostMustRun: TCheckBox;
    cb_imponer_cvea: TCheckBox;
    cmb_ixPEC_borne: TComboBox;
    cmb_ixPEE_borne: TComboBox;
    cmb_ixPEC_fuente: TComboBox;
    cmb_ixPEE_fuente: TComboBox;
    eNPuntos_ECA: TEdit;
    eECA: TEdit;
    eX_EA_inicial: TEdit;
    eTonCO2xMWh: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    lbl_ECA: TLabel;
    lbl_X_EA_inicial: TLabel;
    Label11: TLabel;
    lbl_ixPEC_borne: TLabel;
    lbl_ixPEE_borne: TLabel;
    lbl_ixPEC_fuente: TLabel;
    lbl_ixPEE_fuente: TLabel;
    LNombre: TLabel;
    LNodo: TLabel;
    LFNac: TLabel;
    LFMuerte: TLabel;
    LFichas: TLabel;
    CBNodo: TComboBox;
    EditNombre: TEdit;
    EFNac: TEdit;
    EFMuerte: TEdit;
    sgFichas: TStringGrid;
    BAgregarFicha: TButton;
    BGuardar: TButton;
    BCancelar: TButton;
    Panel1: TPanel;
    BVerExpandida: TButton;
    BEditorDeUnidades: TButton;
    BAyuda: TButton;
    procedure btEditarForzamientosClick(Sender: TObject);
    procedure cb_imponer_cveaChange(Sender: TObject);
    procedure cmb_ixPEE_fuenteChange(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure BAyudaClick(Sender: TObject);
    procedure CBNodoChange(Sender: TObject);
    procedure cmb_ixPEC_fuenteChange(Sender: TObject);
    procedure cmb_ixPEC_borneChange(Sender: TObject);
    procedure BEditorDeUnidadesClick(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure BGuardarClick(Sender: TObject); override;
    procedure rgTipoFuenteClick(Sender: TObject);
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent; sala: TSalaDeJuego;
      tipoCosa: TClass; cosaConNombre: TCosaConNombre); override;
    function validarFormulario: boolean; override;
  end;

implementation

uses SimSEEEditMain;

  {$R *.lfm}

constructor TEditarTBiomasaEmbalsable.Create(AOwner: TComponent;
  sala: TSalaDeJuego; tipoCosa: TClass; cosaConNombre: TCosaConNombre);
var
  actor: TBiomasaEmbalsable;
begin
  inherited Create(AOwner, sala, tipoCosa, cosaConNombre);

  inicializarCBNodos(CBNodo, False);
  utilidades.AgregarFormatoFecha(LFNac);
  utilidades.AgregarFormatoFecha(LFMuerte);

  if TSimSEEEditOptions.getInstance.fechasAutomaticas then
    inherited ocultarFechas(LFNac, LFMuerte, EFNac, EFMuerte);

  inicializarCBFuente(cmb_ixPEC_fuente, cmb_ixPEC_borne, True);
  inicializarCBFuente(cmb_ixPEE_fuente, cmb_ixPEE_borne, True);

  if cosaConNombre <> nil then
  begin
    actor := TBiomasaEmbalsable(cosaConNombre);
    inicializarComponentesLPD(actor.lpd, TFichaBiomasaEmbalsable, sgFichas,
      BAgregarFicha, BVerExpandida, BGuardar, BCancelar);

    EditNombre.Text := actor.nombre;
    setCBNodo(CBNodo, actor.Nodo);
    EFNac.Text := FSimSEEEdit.fechaIniToString(actor.nacimiento);
    EFMuerte.Text := FSimSEEEdit.fechaFinToString(actor.muerte);

    self.eX_EA_inicial.Text := FloatToStr(actor.X_EA_inicial);
    self.eECA.Text := FloatToStr(actor.ECA);
    self.eNPuntos_ECA.Text := IntToStr(actor.NPuntos_ECA);

    setCBFuente(cmb_ixPEC_fuente, cmb_ixPEC_borne, actor.ixPEC_fuente,
      actor.ixPEC_Borne_nombre);
    setCBFuente(cmb_ixPEE_fuente, cmb_ixPEE_borne, actor.ixPEE_fuente,
      actor.ixPEE_Borne_nombre);

    cb_imponer_cvea.Checked:= actor.flg_imponer_cvea;

    eTonCO2xMWh.Text := FloatToStr(actor.TonCO2xMWh);



    cbLowCostMustRun.Checked := actor.LowCostMustRun_;
    cbCleanDevelopmentMechanism.Checked := actor.CleanDevelopmentMechanism;
    guardado := True;
  end
  else
  begin
    inicializarComponentesLPD(nil, TFichaBiomasaEmbalsable, sgFichas,
      BAgregarFicha, BVerExpandida, BGuardar, BCancelar);

    self.eX_EA_inicial.Text := '';
    self.eECA.Text := '';
    self.eNPuntos_ECA.Text := '';
    cb_imponer_cvea.Checked:= false;

    eTonCO2xMWh.Text := FloatToStr(0.0);
    cbLowCostMustRun.Checked := True;
    cbCleanDevelopmentMechanism.Checked := False;
    guardado := False;
  end;
end;

function TEditarTBiomasaEmbalsable.validarFormulario: boolean;
begin
  Result :=
    inherited validarFormulario and validarNombre(EditNombre) and
    validarCBNodo(CBNodo) and validarEditFecha(EFNac) and
    validarEditFecha(EFMuerte) and validarEditFloat(
    eX_EA_inicial) and validarEditFloat(eECA) and
    validarEditInt(eNPuntos_ECA) and validarCBFuente(
    cmb_ixPEC_fuente, cmb_ixPEC_borne, 0) and
    validarEditFloat(eTonCO2xMWh, -1000, 1000000);
end;

procedure TEditarTBiomasaEmbalsable.BAyudaClick(Sender: TObject);
begin
  uverdoc.verdoc(self, tipoCosa);
end;

procedure TEditarTBiomasaEmbalsable.BCancelarClick(Sender: TObject);
begin
  inherited BCancelarClick(Sender);
end;

procedure TEditarTBiomasaEmbalsable.BEditorDeUnidadesClick(Sender: TObject);
begin
  inherited BEditorDeUnidadesClick(Sender);
end;

procedure TEditarTBiomasaEmbalsable.BGuardarClick(Sender: TObject);
var
  actor: TBiomasaEmbalsable;
begin
  if validarFormulario then
  begin
    if cosaConNombre = nil then
    begin
      cosaConNombre := TBiomasaEmbalsable.Create(
        capa, EditNombre.Text,
        FSimSEEEdit.StringToFecha(EFNac.Text),
        FSimSEEEdit.StringToFecha(EFMuerte.Text),
        lpdUnidades, lpd,
        valorCBNodo(CBNodo), StrToFloat(
        eECA.Text), StrToInt(eNPuntos_ECA.Text),
        strToFloat(eX_EA_inicial.Text),
        valorCBFuente(cmb_ixPEC_fuente),
        valorCBString(cmb_ixPEC_borne),
        valorCBFuente(cmb_ixPEE_fuente),
        valorCBString(cmb_ixPEE_borne),
        cb_imponer_cvea.checked,
        StrToFloat(eTonCO2xMWh.Text),
        cbLowCostMustRun.Checked,
        cbCleanDevelopmentMechanism.Checked);
      actor := TBiomasaEmbalsable(cosaConNombre);
    end
    else
    begin
      actor := TBiomasaEmbalsable(cosaConNombre);
      actor.nombre := EditNombre.Text;
      actor.nacimiento.PonerIgualA(EFNac.Text);
      actor.muerte.PonerIgualA(EFMuerte.Text);
      actor.lpdUnidades.Free;
      actor.lpdUnidades := lpdUnidades;
      actor.lpd.Free;
      actor.lpd := lpd;
      actor.nodo := valorCBNodo(CBNodo);
      actor.ECA := StrToFloat(eECA.Text);
      actor.NPuntos_ECA := StrToInt(eNPuntos_ECA.Text);
      actor.X_EA_inicial := StrToFloat(eX_EA_inicial.Text);
      actor.ixPEC_fuente := valorCBFuente(cmb_ixPEC_fuente);
      actor.ixPEC_Borne_nombre := valorCBString(cmb_ixPEC_borne);
      actor.ixPEE_fuente := valorCBFuente(cmb_ixPEE_fuente);
      actor.ixPEE_Borne_nombre := valorCBString(cmb_ixPEE_borne);
      actor.flg_imponer_cvea:= cb_imponer_cvea.Checked;
      actor.TonCO2xMWh := StrToFloat(eTonCO2xMWh.Text);
      actor.LowCostMustRun_ := cbLowCostMustRun.Checked;
      actor.CleanDevelopmentMechanism := cbCleanDevelopmentMechanism.Checked;
    end;
    actor.lpdForzamientos := lpdForzamientos_;
    ModalResult := mrOk;
    notificarGuardarDatos;
  end;
end;

procedure TEditarTBiomasaEmbalsable.rgTipoFuenteClick(Sender: TObject);
begin
  inherited CambiosForm(Sender);
end;

procedure TEditarTBiomasaEmbalsable.cmb_ixPEC_borneChange(Sender: TObject);
begin
  inherited CBBorneChange(cmb_ixPEC_fuente, cmb_ixPEC_borne);
end;

procedure TEditarTBiomasaEmbalsable.cmb_ixPEC_fuenteChange(Sender: TObject);
begin
  inherited CBFuenteChange(Sender, cmb_ixPEC_borne);
end;

procedure TEditarTBiomasaEmbalsable.CBNodoChange(Sender: TObject);
begin
  inherited CBNodoChange(Sender, True);
end;

procedure TEditarTBiomasaEmbalsable.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarTBiomasaEmbalsable.btEditarForzamientosClick(Sender: TObject);
begin
  inherited BEditorDeForzamientosClick(Sender);
end;

procedure TEditarTBiomasaEmbalsable.cb_imponer_cveaChange(Sender: TObject);
begin
  inherited CambiosForm(Sender);
end;


procedure TEditarTBiomasaEmbalsable.cmb_ixPEE_fuenteChange(Sender: TObject);
begin
  inherited CBFuenteChange(Sender, cmb_ixPEE_borne);
end;

procedure TEditarTBiomasaEmbalsable.EditExit(Sender: TObject);
begin
  inherited EditExit(Sender);
end;

procedure TEditarTBiomasaEmbalsable.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;


end.
